/**
  *  \file lfile.h
  */
#ifndef LFILE_H_INCLUDED
#define LFILE_H_INCLUDED

#include <stdio.h>
#include "lispy.h"

class LFile : public LSelfEval {
    FILE* file;
    bool reading;

    LFile(const LFile&);
    LFile& operator=(const LFile&);
 public:
    LFile(FILE* file, bool reading);
    ~LFile();
    std::string toString();
    FILE* getFile()
        { return file; }
    bool isReading() const
        { return reading; }
    bool isWriting() const
        { return !reading; }
    bool equals(LPtr other, bool identical);
    void close();
};

void initFile();
LFile* argFile(LPtr& p);

#endif
